BOOT:
  {
#if defined(dTHX) && !defined(PERL_NO_GET_CONTEXT)
    dTHX;
#endif
    HV *symbol_table = get_hv("Socket::Linux::", GV_ADD);

    static const struct iv_s values_for_iv[] =
      {
#ifdef TCP_NODELAY
        { "TCP_NODELAY", 11, TCP_NODELAY },
#endif
#ifdef TCP_MAXSEG
        { "TCP_MAXSEG", 10, TCP_MAXSEG },
#endif
#ifdef TCP_CORK
        { "TCP_CORK", 8, TCP_CORK },
#endif
#ifdef TCP_KEEPIDLE
        { "TCP_KEEPIDLE", 12, TCP_KEEPIDLE },
#endif
#ifdef TCP_KEEPINTVL
        { "TCP_KEEPINTVL", 13, TCP_KEEPINTVL },
#endif
#ifdef TCP_KEEPCNT
        { "TCP_KEEPCNT", 11, TCP_KEEPCNT },
#endif
#ifdef TCP_SYNCNT
        { "TCP_SYNCNT", 10, TCP_SYNCNT },
#endif
#ifdef TCP_LINGER2
        { "TCP_LINGER2", 11, TCP_LINGER2 },
#endif
#ifdef TCP_DEFER_ACCEPT
        { "TCP_DEFER_ACCEPT", 16, TCP_DEFER_ACCEPT },
#endif
#ifdef TCP_WINDOW_CLAMP
        { "TCP_WINDOW_CLAMP", 16, TCP_WINDOW_CLAMP },
#endif
#ifdef TCP_INFO
        { "TCP_INFO", 8, TCP_INFO },
#endif
#ifdef TCP_QUICKACK
        { "TCP_QUICKACK", 12, TCP_QUICKACK },
#endif
#ifdef TCP_CONGESTION
        { "TCP_CONGESTION", 14, TCP_CONGESTION },
#endif
#ifdef TCP_MD5SIG
        { "TCP_MD5SIG", 10, TCP_MD5SIG },
#endif
#ifdef TCPOPT_EOL
        { "TCPOPT_EOL", 10, TCPOPT_EOL },
#endif
#ifdef TCPOPT_NOP
        { "TCPOPT_NOP", 10, TCPOPT_NOP },
#endif
#ifdef TCPOPT_MAXSEG
        { "TCPOPT_MAXSEG", 13, TCPOPT_MAXSEG },
#endif
#ifdef TCPOLEN_MAXSEG
        { "TCPOLEN_MAXSEG", 14, TCPOLEN_MAXSEG },
#endif
#ifdef TCPOPT_WINDOW
        { "TCPOPT_WINDOW", 13, TCPOPT_WINDOW },
#endif
#ifdef TCPOLEN_WINDOW
        { "TCPOLEN_WINDOW", 14, TCPOLEN_WINDOW },
#endif
#ifdef TCPOPT_SACK_PERMITTED
        { "TCPOPT_SACK_PERMITTED", 21, TCPOPT_SACK_PERMITTED },
#endif
#ifdef TCPOLEN_SACK_PERMITTED
        { "TCPOLEN_SACK_PERMITTED", 22, TCPOLEN_SACK_PERMITTED },
#endif
#ifdef TCPOPT_SACK
        { "TCPOPT_SACK", 11, TCPOPT_SACK },
#endif
#ifdef TCPOPT_TIMESTAMP
        { "TCPOPT_TIMESTAMP", 16, TCPOPT_TIMESTAMP },
#endif
#ifdef TCPOLEN_TIMESTAMP
        { "TCPOLEN_TIMESTAMP", 17, TCPOLEN_TIMESTAMP },
#endif
#ifdef TCPOLEN_TSTAMP_APPA
        { "TCPOLEN_TSTAMP_APPA", 19, TCPOLEN_TSTAMP_APPA },
#endif
#ifdef TCPOPT_TSTAMP_HDR
        { "TCPOPT_TSTAMP_HDR", 17, TCPOPT_TSTAMP_HDR },
#endif
#ifdef TCP_MSS
        { "TCP_MSS", 7, TCP_MSS },
#endif
#ifdef TCP_MAXWIN
        { "TCP_MAXWIN", 10, TCP_MAXWIN },
#endif
#ifdef TCP_MAX_WINSHIFT
        { "TCP_MAX_WINSHIFT", 16, TCP_MAX_WINSHIFT },
#endif
#ifdef SOL_TCP
        { "SOL_TCP", 7, SOL_TCP },
#endif
#ifdef TCPI_OPT_TIMESTAMPS
        { "TCPI_OPT_TIMESTAMPS", 19, TCPI_OPT_TIMESTAMPS },
#endif
#ifdef TCPI_OPT_SACK
        { "TCPI_OPT_SACK", 13, TCPI_OPT_SACK },
#endif
#ifdef TCPI_OPT_WSCALE
        { "TCPI_OPT_WSCALE", 15, TCPI_OPT_WSCALE },
#endif
#ifdef TCPI_OPT_ECN
        { "TCPI_OPT_ECN", 12, TCPI_OPT_ECN },
#endif
#ifdef TCP_MD5SIG_MAXKEYLEN
        { "TCP_MD5SIG_MAXKEYLEN", 20, TCP_MD5SIG_MAXKEYLEN },
#endif
        { NULL, 0, 0 } };
	const struct iv_s *value_for_iv = values_for_iv;
        while (value_for_iv->name) {
	    constant_add_symbol(aTHX_  symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv(value_for_iv->value));
            ++value_for_iv;
	}
	if (C_ARRAY_LENGTH(values_for_notfound) > 1) {
#ifndef SYMBIAN
	    HV *const constant_missing = get_missing_hash(aTHX);
#endif
	    const struct notfound_s *value_for_notfound = values_for_notfound;
	    do {

		/* Need to add prototypes, else parsing will vary by platform.  */
		HE *he = (HE*) hv_common_key_len(symbol_table,
						 value_for_notfound->name,
						 value_for_notfound->namelen,
						 HV_FETCH_LVALUE, NULL, 0);
		SV *sv;
#ifndef SYMBIAN
		HEK *hek;
#endif
		if (!he) {
		    croak("Couldn't add key '%s' to %%Socket::Linux::",
			  value_for_notfound->name);
		}
		sv = HeVAL(he);
		if (!SvOK(sv) && SvTYPE(sv) != SVt_PVGV) {
		    /* Nothing was here before, so mark a prototype of ""  */
		    sv_setpvn(sv, "", 0);
		} else if (SvPOK(sv) && SvCUR(sv) == 0) {
		    /* There is already a prototype of "" - do nothing  */
		} else {
		    /* Someone has been here before us - have to make a real
		       typeglob.  */
		    /* It turns out to be incredibly hard to deal with all the
		       corner cases of sub foo (); and reporting errors correctly,
		       so lets cheat a bit.  Start with a constant subroutine  */
		    CV *cv = newCONSTSUB(symbol_table,
					 value_for_notfound->name,
					 &PL_sv_yes);
		    /* and then turn it into a non constant declaration only.  */
		    SvREFCNT_dec(CvXSUBANY(cv).any_ptr);
		    CvCONST_off(cv);
		    CvXSUB(cv) = NULL;
		    CvXSUBANY(cv).any_ptr = NULL;
		}
#ifndef SYMBIAN
		hek = HeKEY_hek(he);
		if (!hv_common(constant_missing, NULL, HEK_KEY(hek),
 			       HEK_LEN(hek), HEK_FLAGS(hek), HV_FETCH_ISSTORE,
			       &PL_sv_yes, HEK_HASH(hek)))
		    croak("Couldn't add key '%s' to missing_hash",
			  value_for_notfound->name);
#endif
	    } while ((++value_for_notfound)->name);
	}
    /* As we've been creating subroutines, we better invalidate any cached
       methods  */
    mro_method_changed_in(symbol_table);
  }

void
constant(sv)
    INPUT:
	SV *		sv;
    PPCODE:
#ifndef SYMBIAN
	/* It's not obvious how to calculate this at C pre-processor time.
	   However, any compiler optimiser worth its salt should be able to
	   remove the dead code, and hopefully the now-obviously-unused static
	   function too.  */
	HV *constant_missing = (C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? get_missing_hash(aTHX) : NULL;
	if ((C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? hv_exists_ent(constant_missing, sv, 0) : 0) {
	    sv = newSVpvf("Your vendor has not defined Socket::Linux macro %" SVf
			  ", used", sv);
	} else
#endif
	{
	    sv = newSVpvf("%" SVf " is not a valid Socket::Linux macro",
			  sv);
	}
	PUSHs(sv_2mortal(sv));
